#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include <zlib.h>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <pwd.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <fcntl.h>

#define BUFFER_SIZE 8192

void main_keypress(GtkWidget *wid, GdkEventKey *kp) {
  //printf("kp is %d\n",kp->keyval);
  switch (kp->keyval) {
  case 65362: on_back_button_clicked(NULL,NULL);break;      //up
  case 65364: on_forward_button_clicked(NULL,NULL);break;   // down
    //case 65366:on_forward_button_clicked(NULL,NULL);break;
    //case 65365:on_back_button_clicked(NULL,NULL);break;
  case 113: nicequit();break;
  }
}
int myrl(FILE *fp,char *line)  // my 'orrible readline function
{
        int c;
        int i=0;
 
        while ((c=fgetc(fp))!='\n') {
                if (c==EOF) return EOF;
                line[i]=c;
                i++;
        }
        line[i]=(int)NULL;
        return 0;
}
void nicequit() {
  GtkTreeModel *model;
  GtkWidget *bmtree;
  gboolean valid;
  GtkTreeIter iter;
  uid_t uid;
  struct passwd *p;
  FILE *fp;
  char grc[200];

  uid=getuid();
  p=(struct passwd *)getpwuid(uid);
  sprintf(grc,"%s/.greaderc",p->pw_dir);
  fp=fopen(grc,"w");
  fprintf(fp,"%s\n",pr.font_name);
  bmtree=lookup_widget (pr.bmsel, "bm_treeview");
  model=gtk_tree_view_get_model(GTK_TREE_VIEW(bmtree));
  valid = gtk_tree_model_get_iter_first (model, &iter);
  while (valid) {
    gtk_tree_model_get (model, &iter, 0, &pr.bmfile,1,&pr.bmpos,2,&pr.bmdate, -1);
    fprintf(fp,"%s--%s--%s\n",pr.bmfile,pr.bmpos,pr.bmdate);
    valid = gtk_tree_model_iter_next (model, &iter);
  }
  fclose(fp);
  free(pr.font_name);
  gtk_exit(0);
}

void prefload() {
  FILE *fp;
  char *token,*file,*pos;
  char *line;
  GtkWidget *bmtree,*dv;
  GtkTreeStore *store;
  GtkTreeIter iter;
  GtkCellRenderer *rend;
  GtkTreeViewColumn *c1,*c2,*c3;
  GtkTreeSelection *select;
  uid_t uid;
  struct passwd *p;
  char grc[200];

  pr.bmfile=NULL;
  uid=getuid();
  p=getpwuid(uid);
  sprintf(grc,"%s/.greaderc",p->pw_dir);
  fp=fopen(grc,"r");

  pr.bmsel=create_bm_dialog();
  gtk_window_set_transient_for (GTK_WINDOW (pr.bmsel),GTK_WINDOW (pr.mainwin));
  dv = lookup_widget (pr.bmsel, "dialog_vbox1");
  gtk_widget_set_size_request(dv,240,-1);
  bmtree=lookup_widget (pr.bmsel, "bm_treeview");
  store=gtk_tree_store_new (3,G_TYPE_STRING,G_TYPE_STRING,G_TYPE_STRING);
  rend = gtk_cell_renderer_text_new ();    
  (int)pr.font_name=malloc(2048);

  if (fp!=NULL) {

    (int)line=malloc(2048);
    myrl(fp,line);
    strcpy (pr.font_name,line);
    free(line);
    (int)line=malloc(2048);  
    
    while (myrl(fp,line)!=-1) {
      (int)token=strtok(line,"--");
      (int)file=malloc(2048);
      strcpy(file,token);
      (int)token=strtok(NULL,"--");
      (int)pos=malloc(20);
      strcpy(pos,token);
      (int)token=strtok(NULL,"--");
      gtk_tree_store_append (store, &iter, NULL);
      gtk_tree_store_set (store,&iter,0,file,1,pos,2,token,-1);
      select = gtk_tree_view_get_selection (GTK_TREE_VIEW (bmtree));
      gtk_tree_selection_set_mode (select, GTK_SELECTION_SINGLE);
      g_signal_connect (G_OBJECT (select), "changed",G_CALLBACK (tree_selection_changed_cb),NULL);
      
      free(line);
      free(pos);
      free(file);
      (int)line=malloc(2048);
    }

    free(line);
  }
  else strcpy(pr.font_name,"Sans 10");
  gtk_tree_view_set_model(GTK_TREE_VIEW(bmtree),GTK_TREE_MODEL(store));
  c1 = gtk_tree_view_column_new_with_attributes ("File", rend,"text", 0, NULL);
  c2 = gtk_tree_view_column_new_with_attributes ("BM", rend,"text", 1,NULL);
  c3 = gtk_tree_view_column_new_with_attributes ("Date", rend,"text", 2,NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (bmtree), c1);
  gtk_tree_view_append_column (GTK_TREE_VIEW (bmtree), c2);
  gtk_tree_view_append_column (GTK_TREE_VIEW (bmtree), c3);
}

void
on_open_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  if (!pr.filesel) pr.filesel = create_file_selection ();
  gtk_window_set_transient_for (GTK_WINDOW (pr.filesel),GTK_WINDOW (pr.mainwin));
  // Take note of next line for those dependant on libgpe stuff... squishes filerequestor nicely :)
  gtk_widget_set_size_request(GTK_FILE_SELECTION(pr.filesel)->main_vbox,240,-1);
  gtk_window_present (GTK_WINDOW (pr.filesel));
}

void real_open(const gchar *fname) {
  GtkTextBuffer *buffer;
  GtkWidget *view;
  GtkTextIter start, end;
  gzFile *fp; //gzip support
  gchar data[BUFFER_SIZE];
  int bytesread;
  PangoFontDescription *font_desc;
 
  view = lookup_widget (pr.mainwin, "textview");
  buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (view));
  gtk_text_buffer_get_bounds (buffer, &start, &end);
  gtk_text_buffer_delete (buffer, &start, &end);
 
  fp=gzopen(fname,"rb");
   
  for (;;) {
    bytesread=gzread(fp,data,sizeof(gchar)*1024);
     
    gtk_text_buffer_get_end_iter (buffer, &end);
    gtk_text_buffer_insert (buffer, &end, data, bytesread);
     
    if (bytesread<1)
      break;
  }
  gzclose(fp);
  font_desc=pango_font_description_from_string(pr.font_name);
  gtk_widget_modify_font (view,font_desc);
  pango_font_description_free (font_desc);
}


void
on_font_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *fs,*fl,*sw;

  if (!pr.fontsel) pr.fontsel=create_fontselect_dialog();
  // Take note of next 7 lines for those dependant on libgpe stuff... squishes fontrequestor nicely via strictly gtk2 stuff. use the src luke!
  // I need to make these widths dependant on parent window size for sound sizing logic on ipaq vs desktop...
  fs=GTK_FONT_SELECTION_DIALOG(pr.fontsel)->fontsel;
  sw=gtk_widget_get_parent(GTK_FONT_SELECTION(fs)->family_list);
  gtk_widget_set_size_request(sw,70,-1);
  sw=gtk_widget_get_parent(GTK_FONT_SELECTION(fs)->face_list);
  gtk_widget_set_size_request(sw,50,-1);
  sw=gtk_widget_get_parent(GTK_FONT_SELECTION(fs)->size_list);
  gtk_widget_set_size_request(sw,60,-1);

  gtk_widget_set_size_request(GTK_FONT_SELECTION_DIALOG(pr.fontsel)->main_vbox,240,-1);
  gtk_window_present(GTK_WINDOW(pr.fontsel));
}


void
on_fontselect_ok_button_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *fontsel;

  on_fontselect_apply_button_clicked (button, NULL);
  fontsel = gtk_widget_get_toplevel (GTK_WIDGET (button));
  gtk_widget_hide (fontsel);
}


void
on_fontselect_cancel_button_clicked    (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(pr.fontsel);
}

void update_bar(char *text) 
{
  GtkWidget *bar;

  bar = lookup_widget (pr.mainwin, "statusbar1");
  gtk_statusbar_pop (GTK_STATUSBAR (bar), 1);
  gtk_statusbar_push (GTK_STATUSBAR (bar), 1, text);
}

void
on_fontselect_apply_button_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *fontsel,*textview,*statusbar;
  PangoFontDescription *font_desc;

  fontsel=gtk_widget_get_toplevel(GTK_WIDGET (button));
  textview=lookup_widget(pr.mainwin,"textview");

  pr.font_name=gtk_font_selection_dialog_get_font_name(GTK_FONT_SELECTION_DIALOG(fontsel));
  font_desc=pango_font_description_from_string(pr.font_name);
  gtk_widget_modify_font (textview,font_desc);
  pango_font_description_free (font_desc);

  update_bar("Font updated");
}


void
on_bm_button_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkTextMark *mark;
  GtkTextBuffer *buffer;
  GtkWidget *view,*bmtree;
  GtkTextIter cpos;
  GtkTreeIter iter;
  int currentpos;
  char spos[10],*dstr;
  time_t curtime;
  
  GtkTreeStore *store;
  GtkCellRenderer *rend;
  GtkTreeModel *model;


  view = lookup_widget (pr.mainwin, "textview");
  buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (view));
  mark=gtk_text_buffer_get_insert(buffer);
  gtk_text_buffer_get_iter_at_mark(buffer,&cpos,mark);
  currentpos=gtk_text_iter_get_offset(&cpos);

  bmtree=lookup_widget (pr.bmsel, "bm_treeview");
  model=gtk_tree_view_get_model(GTK_TREE_VIEW(bmtree));
  gtk_tree_store_append (GTK_TREE_STORE(model),&iter,NULL);
  sprintf(spos,"%d",currentpos);
  curtime = time (NULL);
  (int)dstr=malloc(60);
  asctime_r(localtime(&curtime),dstr);
  dstr[strlen(dstr)-1]='\0';
  gtk_tree_store_set (GTK_TREE_STORE(model),&iter,0,pr.bmfile,1,spos,2,dstr,-1);
  free(dstr);
  update_bar("Bookmarked!");
}


void
on_forward_button_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *scrollwindow,*textview;
  GtkAdjustment *adj;
  gdouble current,step,new,page;
  char sbar[1024],pstr[10];

  scrollwindow=lookup_widget (pr.mainwin, "scrolledwindow1");
  textview=lookup_widget (pr.mainwin, "textview");
  adj=gtk_scrolled_window_get_vadjustment(GTK_SCROLLED_WINDOW(scrollwindow));
  current=adj->value;
  step=adj->page_increment;
  new=current+step;
  if ((new>adj->upper) || (new==0)) new=adj->upper;
  page=new/(adj->page_increment);
  sprintf(pstr,"%d",(int)page);
  adj->value=new;
  gtk_adjustment_value_changed(adj);
  while (gtk_events_pending()) gtk_main_iteration();
  if (pr.bmfile!=NULL) {
    strcpy(sbar,(char *)basename(pr.bmfile));
    strcat(sbar," - p.");
    strcat(sbar,pstr);
  }
  else strcpy(sbar,"<no file>");
  update_bar(sbar);
}


void
on_back_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *scrollwindow,*textview;
  GtkAdjustment *adj;
  gdouble current,step,new,page;
  char sbar[1024],pstr[10];

  scrollwindow=lookup_widget (pr.mainwin, "scrolledwindow1");
  textview=lookup_widget (pr.mainwin, "textview");
  adj=gtk_scrolled_window_get_vadjustment(GTK_SCROLLED_WINDOW(scrollwindow));
  current=adj->value;
  step=adj->page_increment;
  new=current-step;
  if (new<0)new=0;
  page=new/(adj->page_increment);
  sprintf(pstr,"%d",(int)page);
  adj->value=new;
  gtk_adjustment_value_changed(adj);
  while (gtk_events_pending()) gtk_main_iteration();
  if (pr.bmfile!=NULL) {
    strcpy(sbar,(char *)basename(pr.bmfile));
    strcat(sbar," - p.");
    strcat(sbar,pstr);
  }
  else strcpy(sbar,"<no file>");
  update_bar(sbar);
}


void
on_fileselect_ok_button_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{  
  GtkWidget *filesel;

  filesel = gtk_widget_get_toplevel (GTK_WIDGET (button));
  gtk_widget_hide (filesel);
  (char *)pr.bmfile = gtk_file_selection_get_filename (GTK_FILE_SELECTION (filesel));
  real_open (pr.bmfile);
  update_bar((gchar *)basename(pr.bmfile));
}


void
on_fileselect_cancel_button_clicked    (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(pr.filesel);
}

void
on_zoomin_button_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
 GtkWidget *textview;
 GtkTextAttributes *textattr;
 PangoFontDescription *font_desc;
 int size;
 char fname[255],fsize[10],*fc;
 char *idx;

 textview=lookup_widget (pr.mainwin, "textview");
  if (!pr.font_name) {
    textattr=gtk_text_view_get_default_attributes(GTK_TEXT_VIEW(textview));
    pr.font_name=pango_font_description_to_string(textattr->font);
  }
  (int)idx=rindex(pr.font_name,' ');
  strncpy(fname,pr.font_name,(idx-pr.font_name));
  fname[idx-pr.font_name]=(int)NULL;
  
  strcpy(fsize,idx+1);
  size=atoi(fsize);
  sprintf(fsize," %d",size+1);
  (int)fc=strcat(fname,fsize);
  strcpy(pr.font_name,fc);

  font_desc=pango_font_description_from_string(pr.font_name);
  gtk_widget_modify_font (textview,font_desc);
  pango_font_description_free (font_desc);
}

void
on_zoomout_button_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
 GtkWidget *textview;
 GtkTextAttributes *textattr;
 PangoFontDescription *font_desc;
 int size;
 char fname[255],fsize[10],*fc;
 char *idx;

 textview=lookup_widget (pr.mainwin, "textview");
  if (!pr.font_name) {
    textattr=gtk_text_view_get_default_attributes(GTK_TEXT_VIEW(textview));
    pr.font_name=pango_font_description_to_string(textattr->font);
  }
  (int)idx=rindex(pr.font_name,' ');
  strncpy(fname,pr.font_name,(idx-pr.font_name));
  fname[idx-pr.font_name]=(int)NULL;
  
  strcpy(fsize,idx+1);
  size=atoi(fsize);
  if (size==1) size=2;
  sprintf(fsize," %d",size-1);
  (int)fc=strcat(fname,fsize);
  strcpy(pr.font_name,fc);

  font_desc=pango_font_description_from_string(pr.font_name);
  gtk_widget_modify_font (textview,font_desc);
  pango_font_description_free (font_desc);
}

void
on_main_window_destroy                 (GtkObject       *object,
                                        gpointer         user_data)
{
  nicequit();
}


void
on_load_bm_button_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_window_present (GTK_WINDOW (pr.bmsel));
}


void
on_delete_bm_button_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkTreeIter iter;
  GtkTreeModel *model;

  if (gtk_tree_selection_get_selected (GTK_TREE_SELECTION(pr.selection), &model, &iter)) {
    gtk_tree_store_remove(GTK_TREE_STORE(model),&iter);
  }
    //  gtk_tree_store_append (model, &iter, NULL);
    //  gtk_tree_store_set (model,&iter,0,pr.bmfile,1,spos,2,dstr,-1);
}

void
on_cancel_bm_button_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(pr.bmsel);
}


void
on_apply_bm_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *textview;
  GtkTextMark *mark;
  GtkTextBuffer *buffer;
  GtkTextIter cpos;
  int currentpos;

  real_open(pr.bmfile);
  textview=lookup_widget (pr.mainwin, "textview");
  buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (textview));
  currentpos=atoi(pr.bmpos);
  gtk_text_buffer_get_iter_at_offset(buffer,&cpos,currentpos);
  mark=gtk_text_buffer_create_mark(buffer,"bm",&cpos,1);
  gtk_text_view_scroll_to_mark(GTK_TEXT_VIEW(textview),mark,0.0,FALSE,0.0,0.0);
  gtk_widget_hide(pr.bmsel);

  update_bar((gchar *)basename(pr.bmfile));
}

static void
tree_selection_changed_cb (GtkTreeSelection *selection, gpointer data)
{
  GtkTreeIter iter;
  GtkTreeModel *model;
  
  pr.selection=selection;
  if (gtk_tree_selection_get_selected (pr.selection, &model, &iter)) {
    gtk_tree_model_get (model, &iter, 0, &pr.bmfile,1,&pr.bmpos,2,&pr.bmdate, -1);
    (int)pr.bmiter=&iter;
    //g_print ("bmfile:%s\nbmpos:%s\nbmdate:%s\n", pr.bmfile,pr.bmpos,pr.bmdate);
  }
}

void
on_exit_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{

}

